package com.malk.fengkaili.repository.dao;

import com.malk.fengkaili.repository.entity.FKLDdContactPo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;

import javax.transaction.Transactional;

/**
 * 钉钉花名册同步
 */
@Transactional
public interface FKLDdContactDao extends JpaRepository<FKLDdContactPo, Long>, JpaSpecificationExecutor<FKLDdContactPo> {

    boolean existsByUserId(String userId);
}
