package com.malk.fengkaili.repository.entity;

import com.malk.base.BasePo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Entity;
import javax.persistence.Table;

@Entity
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "fkl_dd_contact")
public class FKLDdContactPo extends BasePo {

    /**
     * 员工Id
     */
    private String userId;

    /**
     * 员工姓名
     */
    private String name;

    /**
     * 员工工号
     */
    private String jobNumber;

    /**
     * 手机号
     */
    private String mobile;

    /**
     * 部门Id
     */
    private long deptId;

    /**
     * 部门名称
     */
    private String deptName;

    /**
     * 同步备注
     */
    private String remark;
}
